#pragma tabsize			0
//#pragma semicolon		1

new const WC3_NAME[]		=	"War3FT MOD";
new const WC3_AUTHOR[]	=	"HSCN";
new const WC3_VERSION[]	=	"1.1";
new const WC3_SITE[]		=	"https://t.me/hscn_war3ft_site";
new const WC3_ICQ[]		=	"https://t.me/hscn_war3ft_icq";
new const WC3_SKYPE[]		=	"https://t.me/hscn_war3ft_skype";


#pragma reqclass	xstats
#pragma reqlib		engine
#pragma reqlib		fun
#pragma reqlib		fakemeta
#pragma reqlib		cstrike
#pragma loadlib		sqlite
#pragma loadlib		mysql
#pragma loadlib		cssb

#include <amxmodx>
#include <amxmisc>
#include <engine>
#include <fun>
#include <fakemeta>
#include <fakemeta_util>
#include <cstrike>
#include <dbi>
#include <sqlx>
#include <hamsandwich>
#include <dhudmessage>
#include <csstats>
#include <xs>
#include <maths.inc>
#include <celltravtrie.inc>
#include <message_stocks.inc>



#include "war3ft/global_functions.h"

#include "war3ft/skills_options.h"
#include "war3ft/skills_options.cpp"

#include "war3ft/xp_options.h"
#include "war3ft/xp_options.cpp"


// Header files that contain function declarations and variables

#include "war3ft/logs/logs.h"
#include "war3ft/chat/chat.h"
#include "war3ft/set_player_model/set_player_model.h"
#include "war3ft/client_buy_weapons/client_buy_weapons.h"
#include "war3ft/block_skills.h"
#include "war3ft/block_races.h"
#include "war3ft/block_items_race.h"
#include "war3ft/block_items.h"
#include "war3ft/customization.h"
#include "war3ft/on_off_options.h"
#include "war3ft/race_options.h"
#include "war3ft/resource.h"
#include "war3ft/constants.cpp"
#include "war3ft/db/db_common.h"
#include "war3ft/db/db_mysqlx.h"
#include "war3ft/db/db_sqlite.h"
#include "war3ft/items.h"
#include "war3ft/XP.h"
#include "war3ft/war3ft.h"
#include "war3ft/cstrike.h"
#include "war3ft/menus.h"
#include "war3ft/shared.h"
#include "war3ft/ultimates.h"
#include "war3ft/loot.h"
#include "war3ft/showwin.h"
#include "war3ft/infokiller.h"
#include "war3ft/item_esp.h"
#include "war3ft/item_death_touch.h"
#include "war3ft/item_health_potion.h"
#include "war3ft/ultimate_timer_divider.h"
#include "war3ft/item_steel_skin.h"
#include "war3ft/race_frost_mag.h"
#include "war3ft/vip_skills.h"
#include "war3ft/shopmenu4.h"
#include "war3ft/item_ice_block.h"
#include "war3ft/item_death_coil.h"
#include "war3ft/item_impale.h"
#include "war3ft/item_sleep.h"
#include "war3ft/item_tranquility.h"
#include "war3ft/system_talisman.h"
#include "war3ft/natives.h"
#include "war3ft/new_menus_changerace.h"
#include "war3ft/autobuy_items.h"
#include "war3ft/multi_xp.h"
#include "war3ft/race_death_knight.h"
#include "war3ft/race_black_magician.h"
#include "war3ft/race_priest.h"
#include "war3ft/race_rogue.h"
#include "war3ft/race_druid.h"
#include "war3ft/motd.h"
#include "war3ft/races/bloodseeker/race_bloodseeker.h"
#include "war3ft/races/juggernaut/race_juggernaut.h"
#include "war3ft/races/sniper/race_sniper.h"
#include "war3ft/races/disruptor/race_disruptor.h"
#include "war3ft/races/razor/race_razor.h"
#include "war3ft/races/warlock/race_warlock.h"
#include "war3ft/races/shadow_fiend/race_shadow_fiend.h"
#include "war3ft/health/health.h"
#include "war3ft/armor/armor.h"
#include "war3ft/vip_system/vip_system.h"

// Source Code
#include "war3ft/cvar.cpp"

#include "war3ft/chat/chat.cpp"
#include "war3ft/race_undead.cpp"         							// Undead Scourge   - 1
#include "war3ft/race_human.cpp"									// Human Alliance	- 2
#include "war3ft/race_orc.cpp"										// Orcish Horde		- 3
#include "war3ft/race_elf.cpp"										// Night Elf		- 4
#include "war3ft/race_blood.cpp"									// Blood Mage		- 5
#include "war3ft/race_shadow.cpp"									// Shadow Hunter	- 6
#include "war3ft/race_warden.cpp"          							// Warden           - 7
#include "war3ft/race_crypt.cpp"									// Crypt Lord       - 8
#include "war3ft/race_chameleon.cpp"								// Chameleon		- 9
#include "war3ft/race_frost_mag.cpp"								// Frost Mage		- 10
#include "war3ft/race_death_knight.cpp"								// Death knight		- 11
#include "war3ft/race_black_magician.cpp"							// Black magician	- 12
#include "war3ft/race_alchemist.cpp"								// Alchemis			- 13
#include "war3ft/race_priest.cpp"									// Priest			- 14
#include "war3ft/race_rogue.cpp"									// Rogue			- 15
#include "war3ft/race_druid.cpp"									// Druid			- 16
#include "war3ft/races/bloodseeker/race_bloodseeker.cpp"			// Bloodseeker		- 17
#include "war3ft/races/juggernaut/race_juggernaut.cpp"				// Juggernaut		- 18
#include "war3ft/races/sniper/race_sniper.cpp"						// Sniper			- 19
#include "war3ft/races/disruptor/race_disruptor.cpp"				// Disruptor		- 20
#include "war3ft/races/razor/race_razor.cpp"						// Razor			- 21
#include "war3ft/races/warlock/race_warlock.cpp"					// Warlock			- 22
#include "war3ft/races/shadow_fiend/race_shadow_fiend.cpp"			// Shadow Fiend		- 23

#include "war3ft/forwards.cpp"
#include "war3ft/effects.cpp"
#include "war3ft/XP.cpp"
#include "war3ft/db/db_mysqlx.cpp"
#include "war3ft/db/db_sqlite.cpp"
#include "war3ft/db/db_common.cpp"
#include "war3ft/war3ft.cpp"
#include "war3ft/events.cpp"
#include "war3ft/clientCommands.cpp"
#include "war3ft/items.cpp"
#include "war3ft/stocks.cpp"
#include "war3ft/shared.cpp"
#include "war3ft/menus.cpp"
#include "war3ft/motd.cpp"
#include "war3ft/language.cpp"
#include "war3ft/admin.cpp"
#include "war3ft/ultimates.cpp"
#include "war3ft/util.cpp"
#include "war3ft/skill_manager.cpp"
#include "war3ft/cstrike.cpp"
#include "war3ft/loot.cpp"
#include "war3ft/showwin.cpp"
#include "war3ft/infokiller.cpp"
#include "war3ft/item_esp.cpp"
#include "war3ft/item_death_touch.cpp"
#include "war3ft/item_health_potion.cpp"
#include "war3ft/ultimate_timer_divider.cpp"
#include "war3ft/item_steel_skin.cpp"
#include "war3ft/ult_race_blood.cpp"
#include "war3ft/vip_skills.cpp"
#include "war3ft/shopmenu4.cpp"
#include "war3ft/item_ice_block.cpp"
#include "war3ft/item_death_coil.cpp"
#include "war3ft/item_impale.cpp"
#include "war3ft/item_sleep.cpp"
#include "war3ft/race_vip_models.cpp"
#include "war3ft/item_tranquility.cpp"
#include "war3ft/system_talisman.cpp"
#include "war3ft/natives.cpp"
#include "war3ft/new_menus_changerace.cpp"
#include "war3ft/autobuy_items.cpp"
#include "war3ft/customization.cpp"
#include "war3ft/multi_xp.cpp"
#include "war3ft/global_functions.cpp"
#include "war3ft/block_items.cpp"
#include "war3ft/block_items_race.cpp"
#include "war3ft/block_races.cpp"
#include "war3ft/block_skills.cpp"
#include "war3ft/logs/logs.cpp"
#include "war3ft/functions/plugin_init.cpp"
#include "war3ft/functions/plugin_end.cpp"
#include "war3ft/functions/plugin_precache.cpp"
#include "war3ft/functions/client_putinserver.cpp"
#include "war3ft/functions/client_connect.cpp"
#include "war3ft/functions/client_disconnect.cpp"
#include "war3ft/functions/client_PreThink.cpp"
#include "war3ft/functions/plugin_natives.cpp"
#include "war3ft/functions/plugin_modules.cpp"
#include "war3ft/functions/error_filter.cpp"
#include "war3ft/functions/module_filter.cpp"
#include "war3ft/functions/native_filter.cpp"
#include "war3ft/functions/plugin_cfg.cpp"
#include "war3ft/functions/client_command.cpp"
#include "war3ft/functions/CS_InternalCommand.cpp"
#include "war3ft/client_buy_weapons/client_buy_weapons.cpp"
#include "war3ft/set_player_model/set_player_model.cpp"
#include "war3ft/health/health.cpp"
#include "war3ft/armor/armor.cpp"
#include "war3ft/vip_system/vip_system.cpp"
